 float4x4 tW: WORLD;        //the models world matrix
float4x4 tV: VIEW;         //view matrix as set via Renderer (DX9)
float4x4 tWV: WORLDVIEW;
float4x4 tWVP: WORLDVIEWPROJECTION;
float4x4 tP: PROJECTION;   //projection matrix as set via Renderer (DX9)

texture Tex <string uiname="Texture1";>;
float4x4 tTex <string uiname="Texture Transform";>;                  //Texture Transform
sampler Samp = sampler_state    //sampler for doing the texture-lookup
{
    Texture   = (Tex);          //apply a texture to the sampler
    MipFilter = LINEAR;         //set the sampler states
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

texture BTex2 <string uiname="Mask/wipe Texture";>;
float4x4 tBTex2 <string uiname="Mask/wipe Texture Transform";>;                  //Texture Transform
sampler BSamp2 = sampler_state    //sampler for doing the texture-lookup
{
    Texture   = (BTex2);          //apply a texture to the sampler
    MipFilter = LINEAR;         //set the sampler states
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

 texture Tex2 <string uiname="Texture2";>;
float4x4 tTex2 <string uiname="Texture Transform2";>;                  //Texture Transform
sampler Samp2 = sampler_state    //sampler for doing the texture-lookup
{
    Texture   = (Tex2);          //apply a texture to the sampler
    MipFilter = LINEAR;         //set the sampler states
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

///////////////////////////////////////////vertexshader////////////////////////

struct VS_OUTPUT
{
    float4 Pos  : POSITION;
    float4 TexC : TEXCOORD0;
    float4 TexC1 : TEXCOORD1;
    float4 TexC2 : TEXCOORD2;
};

VS_OUTPUT VS(
    float4 Pos  : POSITION,
    float4 TexC : TEXCOORD0
    )
{
    //inititalize all fields of output struct with 0
    VS_OUTPUT Out = (VS_OUTPUT)0;

    //transform position
    Pos = mul(Pos, tWVP);
    //transform texturecoordinates
    Out.TexC1 = mul(TexC, tTex);
    Out.TexC2 = mul(TexC, tTex2);
    
    TexC = mul(TexC, tBTex2);
    Out.Pos  = Pos;
    Out.TexC = TexC;

    return Out;
}
/////////////////////////////////pixel shader //////////////////////////////



float4 PS2(float2 TexC: TEXCOORD0,float2 TexC1: TEXCOORD1,float2 TexC2: TEXCOORD2) : COLOR
{

    float4 col3 = tex2D(Samp, TexC1);
    float4 col4 = tex2D(Samp2, TexC2);
    float4 col5 = tex2D(BSamp2, TexC);
    float4 col7 = {( (1,1,1) - col5.rgb),col5.a};
    float4 col6 = col5 * col3 ;
    float4 col8 = col4 * col7;
    float4 col10 = col6 + col8;
    return col10;
}
float4 PS3(float2 TexC: TEXCOORD0,float2 TexC1: TEXCOORD1,float2 TexC2: TEXCOORD2) : COLOR
{

    float4 col = tex2D( BSamp2, TexC);
    float4 col2 = {( (1,1,1) - col.rgb),col.a};
    float4 col3 = tex2D( Samp, TexC1*col);
    col3 =  col3 * col;
    float4 col4 = tex2D( Samp2, TexC2*col2);
    col4 = col4 * col2;
    float4 col5 = col3 + col4;
      return  col5;
}


/////////////////////////////////////////////////// Technique //////////////


technique normal_wipe {
	pass p0 {
		VertexShader = compile vs_1_1 VS();
		PixelShader  = compile ps_2_0 PS2();
	}
}
technique displacecoordinate_wipe {
	pass p0 {
		VertexShader = compile vs_1_1 VS();
		PixelShader  = compile ps_2_0 PS3();
	}
}
